# CEGUI::FrameWindow Class Reference

Abstract base class for a movable, sizable, window with a title-bar and a frame. More...

Inheritance diagram for CEGUI::FrameWindow:

[legend]
Collaboration diagram for CEGUI::FrameWindow:

[legend]
List of all members.

## Public Types

enum | SizingLocation { SizingNone, SizingTopLeft, SizingTopRight, SizingBottomLeft, SizingBottomRight, SizingTop, SizingLeft, SizingBottom, SizingRight }
| Enumeration that defines the set of possible locations for the mouse on a frame windows sizing border. More...

## Public Member Functions

virtual void | initialise (void)
| Initialises the Window based object ready for use.
bool | isSizingEnabled (void) const
| Return whether this window is sizable. Note that this requires that the window have an enabled frame and that sizing itself is enabled.
bool | isFrameEnabled (void) const
| Return whether the frame for this window is enabled.
bool | isTitleBarEnabled (void) const
| Return whether the title bar for this window is enabled.
bool | isCloseButtonEnabled (void) const
| Return whether this close button for this window is enabled.
bool | isRollupEnabled (void) const
| Return whether roll up (a.k.a shading) is enabled for this window.
bool | isRolledup (void) const
| Return whether the window is currently rolled up (a.k.a shaded).
float | getSizingBorderThickness (void) const
| Return the thickness of the sizing border.
void | setSizingEnabled (bool setting)
| Enables or disables sizing for this window.
void | setFrameEnabled (bool setting)
| Enables or disables the frame for this window.
void | setTitleBarEnabled (bool setting)
| Enables or disables the title bar for the frame window.
void | setCloseButtonEnabled (bool setting)
| Enables or disables the close button for the frame window.
void | setRollupEnabled (bool setting)
| Enables or disables roll-up (shading) for this window.
void | toggleRollup (void)
| Toggles the state of the window between rolled-up (shaded) and normal sizes. This requires roll-up to be enabled.
void | setSizingBorderThickness (float pixels)
| Set the size of the sizing border for this window.
void | setTitlebarFont (const String &name)
| Set the font to use for the title bar text.
void | setTitlebarFont (Font *font)
| Set the font to use for the title bar text.
void | offsetPixelPosition (const Vector2 &offset)
| Move the window by the pixel offsets specified in offset.
bool | isDragMovingEnabled (void) const
| Return whether this FrameWindow can be moved by dragging the title bar.
void | setDragMovingEnabled (bool setting)
| Set whether this FrameWindow can be moved by dragging the title bar.
const Font * | getTitlebarFont (void) const
| Return the font being used for the title bar text.
colour | getCaptionColour (void) const
| Return the current colour used for rendering the caption text.
void | setCaptionColour (colour col)
| Sets the colour to be used for rendering the caption text.
const Image * | getNSSizingCursorImage () const
| Return a pointer to the currently set Image to be used for the north-south sizing mouse cursor.
const Image * | getEWSizingCursorImage () const
| Return a pointer to the currently set Image to be used for the east-west sizing mouse cursor.
const Image * | getNWSESizingCursorImage () const
| Return a pointer to the currently set Image to be used for the northwest-southeast sizing mouse cursor.
const Image * | getNESWSizingCursorImage () const
| Return a pointer to the currently set Image to be used for the northeast-southwest sizing mouse cursor.
void | setNSSizingCursorImage (const Image *image)
| Set the Image to be used for the north-south sizing mouse cursor.
void | setEWSizingCursorImage (const Image *image)
| Set the Image to be used for the east-west sizing mouse cursor.
void | setNWSESizingCursorImage (const Image *image)
| Set the Image to be used for the northwest-southeast sizing mouse cursor.
void | setNESWSizingCursorImage (const Image *image)
| Set the Image to be used for the northeast-southwest sizing mouse cursor.
void | setNSSizingCursorImage (const String &imageset, const String &image)
| Set the image to be used for the north-south sizing mouse cursor.
void | setEWSizingCursorImage (const String &imageset, const String &image)
| Set the image to be used for the east-west sizing mouse cursor.
void | setNWSESizingCursorImage (const String &imageset, const String &image)
| Set the image to be used for the northwest-southeast sizing mouse cursor.
void | setNESWSizingCursorImage (const String &imageset, const String &image)
| Set the image to be used for the northeast-southwest sizing mouse cursor.
bool | isHit (const Point &position) const
| check if the given position would hit this window.
| FrameWindow (const String &name, const String &type)
| Constructor for FrameWindow objects.
virtual | ~FrameWindow (void)
| Destructor for FramwWindow objects.

## Static Public Attributes

static const String | EventNamespace
| Namespace for global events.
static const String | EventRollupToggled
| Fired when the rollup (shade) state of the window changes.
static const String | EventCloseClicked
| Fired when the close button for the window is clicked.
static const float | DefaultSizingBorderSize = 8.0f
| Default size for the sizing border (in pixels).

## Protected Member Functions

virtual Titlebar * | createTitlebar (const String &name) const =0
| Create a control based upon the Titlebar base class to be used as the title bar for this window.
virtual PushButton * | createCloseButton (const String &name) const =0
| Create a control based upon the PushButton base class, to be used at the close button for the window.
void | moveLeftEdge (float delta)
| move the window's left edge by 'delta'. The rest of the window does not move, thus this changes the size of the Window.
void | moveRightEdge (float delta)
| move the window's right edge by 'delta'. The rest of the window does not move, thus this changes the size of the Window.
void | moveTopEdge (float delta)
| move the window's top edge by 'delta'. The rest of the window does not move, thus this changes the size of the Window.
void | moveBottomEdge (float delta)
| move the window's bottom edge by 'delta'. The rest of the window does not move, thus this changes the size of the Window.
SizingLocation | getSizingBorderAtPoint (const Point &pt) const
| check local pixel co-ordinate point 'pt' and return one of the SizingLocation enumerated values depending where the point falls on the sizing border.
bool | isLeftSizingLocation (SizingLocation loc) const
| return true if given SizingLocation is on left edge.
bool | isRightSizingLocation (SizingLocation loc) const
| return true if given SizingLocation is on right edge.
bool | isTopSizingLocation (SizingLocation loc) const
| return true if given SizingLocation is on top edge.
bool | isBottomSizingLocation (SizingLocation loc) const
| return true if given SizingLocation is on bottom edge.
void | addFrameWindowEvents (void)
| Add frame window specific events.
bool | closeClickHandler (const EventArgs &e)
| Method to respond to close button click events and fire our close event.
void | setCursorForPoint (const Point &pt) const
| Set the appropriate mouse cursor for the given window-relative pixel point.
virtual Rect | getSizingRect (void) const
| Return a Rect that describes, in window relative pixel co-ordinates, the outer edge of the sizing area for this window.
virtual bool | testClassName_impl (const String &class_name) const
| Return whether this window was inherited from the given class name at some point in the inheritance heirarchy.
virtual void | onRollupToggled (WindowEventArgs &e)
| Event generated internally whenever the roll-up / shade state of the window changes.
virtual void | onCloseClicked (WindowEventArgs &e)
| Event generated internally whenever the close button is clicked.
virtual void | onMouseMove (MouseEventArgs &e)
| Handler called when the mouse cursor has been moved within this window's area.
virtual void | onMouseButtonDown (MouseEventArgs &e)
| Handler called when a mouse button has been depressed within this window's area.
virtual void | onMouseButtonUp (MouseEventArgs &e)
| Handler called when a mouse button has been released within this window's area.
virtual void | onCaptureLost (WindowEventArgs &e)
| Handler called when this window loses capture of mouse inputs.
virtual void | onTextChanged (WindowEventArgs &e)
| Handler called when the window's text is changed.
virtual void | onActivated (ActivationEventArgs &e)
| Handler called when this window has become the active window.
virtual void | onDeactivated (ActivationEventArgs &e)
| Handler called when this window has lost input focus and has been deactivated.

## Protected Attributes

bool | d_frameEnabled
| true if window frame should be drawn.
bool | d_rollupEnabled
| true if roll-up of window is allowed.
bool | d_rolledup
| true if window is rolled up.
bool | d_sizingEnabled
| true if sizing is enabled for this window.
bool | d_beingSized
| true if window is being sized.
float | d_borderSize
| thickness of the sizing border around this window
Point | d_dragPoint
| point window is being dragged at.
Titlebar * | d_titlebar
| points to the title bar widget.
PushButton * | d_closeButton
| points to close button widget.
const Image * | d_nsSizingCursor
| North/South sizing cursor image.
const Image * | d_ewSizingCursor
| East/West sizing cursor image.
const Image * | d_nwseSizingCursor
| North-West/South-East cursor image.
const Image * | d_neswSizingCursor
| North-East/South-West cursor image.
bool | d_dragMovable
| true if the window will move when dragged by the title bar.

## Detailed Description

Abstract base class for a movable, sizable, window with a title-bar and a frame.

## Member Enumeration Documentation

enum CEGUI::FrameWindow::SizingLocation

Enumeration that defines the set of possible locations for the mouse on a frame windows sizing border.

Enumerator:

  SizingNone | Position is not a sizing location.
  SizingTopLeft | Position will size from the top-left.
  SizingTopRight | Position will size from the top-right.
  SizingBottomLeft | Position will size from the bottom left.
  SizingBottomRight | Position will size from the bottom right.
  SizingTop | Position will size from the top.
  SizingLeft | Position will size from the left.
  SizingBottom | Position will size from the bottom.
  SizingRight | Position will size from the right.

## Member Function Documentation

virtual PushButton* CEGUI::FrameWindow::createCloseButton | ( | const String & | name | ) | const`[protected, pure virtual]`

Create a control based upon the PushButton base class, to be used at the close button for the window.

Parameters:

  | name | String object holding the name that must be used when creating the close button.

Returns:
  Pointer to an object who's class derives from PushButton.

virtual Titlebar* CEGUI::FrameWindow::createTitlebar | ( | const String & | name | ) | const`[protected, pure virtual]`

Create a control based upon the Titlebar base class to be used as the title bar for this window.

Parameters:

  | name | String object holding the name that must be used when creating the titlebar.

Returns:
  Pointer to an object who's class derives from Titlebar

colour CEGUI::FrameWindow::getCaptionColour | ( | void |  | ) | const

Return the current colour used for rendering the caption text.

Returns:
  colour value that specifies the colour used when rendering the title bar caption text.

const Image * CEGUI::FrameWindow::getEWSizingCursorImage | ( |  | ) | const

Return a pointer to the currently set Image to be used for the east-west sizing mouse cursor.

Returns:
  Pointer to an Image object, or 0 for none.

const Image * CEGUI::FrameWindow::getNESWSizingCursorImage | ( |  | ) | const

Return a pointer to the currently set Image to be used for the northeast-southwest sizing mouse cursor.

Returns:
  Pointer to an Image object, or 0 for none.

const Image * CEGUI::FrameWindow::getNSSizingCursorImage | ( |  | ) | const

Return a pointer to the currently set Image to be used for the north-south sizing mouse cursor.

Returns:
  Pointer to an Image object, or 0 for none.

const Image * CEGUI::FrameWindow::getNWSESizingCursorImage | ( |  | ) | const

Return a pointer to the currently set Image to be used for the northwest-southeast sizing mouse cursor.

Returns:
  Pointer to an Image object, or 0 for none.

FrameWindow::SizingLocation CEGUI::FrameWindow::getSizingBorderAtPoint | ( | const Point & | pt | ) | const`[protected]`

check local pixel co-ordinate point 'pt' and return one of the SizingLocation enumerated values depending where the point falls on the sizing border.

Parameters:

  | pt | Point object describing, in pixels, the window relative offset to check.

Returns:
  One of the SizingLocation enumerated values that describe which part of the sizing border that pt corresponded to, if any.

float CEGUI::FrameWindow::getSizingBorderThickness | ( | void |  | ) | const`[inline]`

Return the thickness of the sizing border.

Returns:
  float value describing the thickness of the sizing border in screen pixels.

const Font * CEGUI::FrameWindow::getTitlebarFont | ( | void |  | ) | const

Return the font being used for the title bar text.

Returns:
  Pointer to the Font being used for the TitleBar on this FrameWindow.

void CEGUI::FrameWindow::initialise | ( | void |  | ) | `[virtual]`

Initialises the Window based object ready for use.

Note:
  This must be called for every window created. Normally this is handled automatically by the WindowFactory for each Window type.

Returns:
  Nothing

Reimplemented from CEGUI::Window.

bool CEGUI::FrameWindow::isBottomSizingLocation | ( | SizingLocation | loc | ) | const`[inline, protected]`

return true if given SizingLocation is on bottom edge.

Parameters:

  | loc | SizingLocation value to be checked.

Returns:
  true if loc is on the bottom edge. false if loc is not on the bottom edge.

bool CEGUI::FrameWindow::isCloseButtonEnabled | ( | void |  | ) | const`[inline]`

Return whether this close button for this window is enabled.

Returns:
  true if the window has a close button and it is enabled, false if the window either has no close button or if the close button is disabled.

bool CEGUI::FrameWindow::isDragMovingEnabled | ( | void |  | ) | const`[inline]`

Return whether this FrameWindow can be moved by dragging the title bar.

Returns:
  true if the Window will move when the user drags the title bar, false if the window will not move.

bool CEGUI::FrameWindow::isFrameEnabled | ( | void |  | ) | const`[inline]`

Return whether the frame for this window is enabled.

Returns:
  true if the frame for this window is enabled, false if the frame for this window is disabled.

bool CEGUI::FrameWindow::isHit | ( | const Point & | position | ) | const`[inline, virtual]`

check if the given position would hit this window.

Parameters:

  | position | Point object describing the position to check in screen pixels

Returns:
  true if position 'hits' this Window, else false.

Reimplemented from CEGUI::Window.

bool CEGUI::FrameWindow::isLeftSizingLocation | ( | SizingLocation | loc | ) | const`[inline, protected]`

return true if given SizingLocation is on left edge.

Parameters:

  | loc | SizingLocation value to be checked.

Returns:
  true if loc is on the left edge. false if loc is not on the left edge.

bool CEGUI::FrameWindow::isRightSizingLocation | ( | SizingLocation | loc | ) | const`[inline, protected]`

return true if given SizingLocation is on right edge.

Parameters:

  | loc | SizingLocation value to be checked.

Returns:
  true if loc is on the right edge. false if loc is not on the right edge.

bool CEGUI::FrameWindow::isRolledup | ( | void |  | ) | const`[inline]`

Return whether the window is currently rolled up (a.k.a shaded).

Returns:
  true if the window is rolled up, false if the window is not rolled up.

bool CEGUI::FrameWindow::isRollupEnabled | ( | void |  | ) | const`[inline]`

Return whether roll up (a.k.a shading) is enabled for this window.

Returns:
  true if roll up is enabled, false if roll up is disabled.

bool CEGUI::FrameWindow::isSizingEnabled | ( | void |  | ) | const`[inline]`

Return whether this window is sizable. Note that this requires that the window have an enabled frame and that sizing itself is enabled.

Returns:
  true if the window can be sized, false if the window can not be sized

bool CEGUI::FrameWindow::isTitleBarEnabled | ( | void |  | ) | const`[inline]`

Return whether the title bar for this window is enabled.

Returns:
  true if the window has a title bar and it is enabled, false if the window has no title bar or if the title bar is disabled.

bool CEGUI::FrameWindow::isTopSizingLocation | ( | SizingLocation | loc | ) | const`[inline, protected]`

return true if given SizingLocation is on top edge.

Parameters:

  | loc | SizingLocation value to be checked.

Returns:
  true if loc is on the top edge. false if loc is not on the top edge.

void CEGUI::FrameWindow::moveBottomEdge | ( | float | delta | ) | `[protected]`

move the window's bottom edge by 'delta'. The rest of the window does not move, thus this changes the size of the Window.

Parameters:

  | delta | float value that specifies the amount to move the window edge, and in which direction. Positive values make window larger.

void CEGUI::FrameWindow::moveLeftEdge | ( | float | delta | ) | `[protected]`

move the window's left edge by 'delta'. The rest of the window does not move, thus this changes the size of the Window.

Parameters:

  | delta | float value that specifies the amount to move the window edge, and in which direction. Positive values make window smaller.

void CEGUI::FrameWindow::moveRightEdge | ( | float | delta | ) | `[protected]`

move the window's right edge by 'delta'. The rest of the window does not move, thus this changes the size of the Window.

Parameters:

  | delta | float value that specifies the amount to move the window edge, and in which direction. Positive values make window larger.

void CEGUI::FrameWindow::moveTopEdge | ( | float | delta | ) | `[protected]`

move the window's top edge by 'delta'. The rest of the window does not move, thus this changes the size of the Window.

Parameters:

  | delta | float value that specifies the amount to move the window edge, and in which direction. Positive values make window smaller.

void CEGUI::FrameWindow::offsetPixelPosition | ( | const Vector2 & | offset | ) |

Move the window by the pixel offsets specified in offset.

This is intended for internal system use - it is the method by which the title bar moves the frame window.

Parameters:

  | offset | Vector2 object containing the offsets to apply (offsets are in screen pixels).

Returns:
  Nothing.

void CEGUI::FrameWindow::onActivated | ( | ActivationEventArgs & | e | ) | `[protected, virtual]`

Handler called when this window has become the active window.

Parameters:

  | e | ActivationEventArgs class whose 'otherWindow' field is set to the window that previously was active, or NULL for none.

Reimplemented from CEGUI::Window.

void CEGUI::FrameWindow::onCaptureLost | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when this window loses capture of mouse inputs.

Parameters:

  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented from CEGUI::Window.

void CEGUI::FrameWindow::onDeactivated | ( | ActivationEventArgs & | e | ) | `[protected, virtual]`

Handler called when this window has lost input focus and has been deactivated.

Parameters:

  | e | ActivationEventArgs object whose 'otherWindow' field is set to the window that has now become active, or NULL for none.

Reimplemented from CEGUI::Window.

void CEGUI::FrameWindow::onMouseButtonDown | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when a mouse button has been depressed within this window's area.

Parameters:

  | e | MouseEventArgs object. All fields are valid.

Reimplemented from CEGUI::Window.

void CEGUI::FrameWindow::onMouseButtonUp | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when a mouse button has been released within this window's area.

Parameters:

  | e | MouseEventArgs object. All fields are valid.

Reimplemented from CEGUI::Window.

void CEGUI::FrameWindow::onMouseMove | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

Handler called when the mouse cursor has been moved within this window's area.

Parameters:

  | e | MouseEventArgs object. All fields are valid.

Reimplemented from CEGUI::Window.

void CEGUI::FrameWindow::onTextChanged | ( | WindowEventArgs & | e | ) | `[protected, virtual]`

Handler called when the window's text is changed.

Parameters:

  | e | WindowEventArgs object whose 'window' pointer field is set to the window that triggered the event. For this event the trigger window is always 'this'.

Reimplemented from CEGUI::Window.

void CEGUI::FrameWindow::setCaptionColour | ( | colour | col | ) |

Sets the colour to be used for rendering the caption text.

Parameters:

  | col | colour value that specifies the colour to be used when rendering the title bar caption text.

Returns:
  Nothing.

void CEGUI::FrameWindow::setCloseButtonEnabled | ( | bool | setting | ) |

Enables or disables the close button for the frame window.

Parameters:

  | setting | Set to true to enable the close button (if one is attached), or false to disable the close button.

Returns:
  Nothing.

void CEGUI::FrameWindow::setDragMovingEnabled | ( | bool | setting | ) |

Set whether this FrameWindow can be moved by dragging the title bar.

Parameters:

  | setting | true if the Window should move when the user drags the title bar, false if the window should not move.

Returns:
  Nothing.

void CEGUI::FrameWindow::setEWSizingCursorImage | ( | const String & | imageset,
|  | const String & | image
| ) |

Set the image to be used for the east-west sizing mouse cursor.

Parameters:

  | imageset | String holding the name of the Imageset containing the Image to be used.
  | image | String holding the name of the Image to be used.

Returns:
  Nothing.

Exceptions:

  | UnknownObjectException | thrown if either imageset or image refer to non-existant entities.

void CEGUI::FrameWindow::setEWSizingCursorImage | ( | const Image * | image | ) |

Set the Image to be used for the east-west sizing mouse cursor.

Parameters:

  | image | Pointer to an Image object, or 0 for none.

Returns:
  Nothing.

void CEGUI::FrameWindow::setFrameEnabled | ( | bool | setting | ) |

Enables or disables the frame for this window.

Parameters:

  | setting | set to true to enable the frame for this window, or false to disable the frame for this window.

Returns:
  Nothing.

void CEGUI::FrameWindow::setNESWSizingCursorImage | ( | const String & | imageset,
|  | const String & | image
| ) |

Set the image to be used for the northeast-southwest sizing mouse cursor.

Parameters:

  | imageset | String holding the name of the Imageset containing the Image to be used.
  | image | String holding the name of the Image to be used.

Returns:
  Nothing.

Exceptions:

  | UnknownObjectException | thrown if either imageset or image refer to non-existant entities.

void CEGUI::FrameWindow::setNESWSizingCursorImage | ( | const Image * | image | ) |

Set the Image to be used for the northeast-southwest sizing mouse cursor.

Parameters:

  | image | Pointer to an Image object, or 0 for none.

Returns:
  Nothing.

void CEGUI::FrameWindow::setNSSizingCursorImage | ( | const String & | imageset,
|  | const String & | image
| ) |

Set the image to be used for the north-south sizing mouse cursor.

Parameters:

  | imageset | String holding the name of the Imageset containing the Image to be used.
  | image | String holding the name of the Image to be used.

Returns:
  Nothing.

Exceptions:

  | UnknownObjectException | thrown if either imageset or image refer to non-existant entities.

void CEGUI::FrameWindow::setNSSizingCursorImage | ( | const Image * | image | ) |

Set the Image to be used for the north-south sizing mouse cursor.

Parameters:

  | image | Pointer to an Image object, or 0 for none.

Returns:
  Nothing.

void CEGUI::FrameWindow::setNWSESizingCursorImage | ( | const String & | imageset,
|  | const String & | image
| ) |

Set the image to be used for the northwest-southeast sizing mouse cursor.

Parameters:

  | imageset | String holding the name of the Imageset containing the Image to be used.
  | image | String holding the name of the Image to be used.

Returns:
  Nothing.

Exceptions:

  | UnknownObjectException | thrown if either imageset or image refer to non-existant entities.

void CEGUI::FrameWindow::setNWSESizingCursorImage | ( | const Image * | image | ) |

Set the Image to be used for the northwest-southeast sizing mouse cursor.

Parameters:

  | image | Pointer to an Image object, or 0 for none.

Returns:
  Nothing.

void CEGUI::FrameWindow::setRollupEnabled | ( | bool | setting | ) |

Enables or disables roll-up (shading) for this window.

Parameters:

  | setting | Set to true to enable roll-up for the frame window, or false to disable roll-up.

Returns:
  Nothing.

void CEGUI::FrameWindow::setSizingBorderThickness | ( | float | pixels | ) | `[inline]`

Set the size of the sizing border for this window.

Parameters:

  | pixels | float value specifying the thickness for the sizing border in screen pixels.

Returns:
  Nothing.

void CEGUI::FrameWindow::setSizingEnabled | ( | bool | setting | ) |

Enables or disables sizing for this window.

Parameters:

  | setting | set to true to enable sizing (also requires frame to be enabled), or false to disable sizing.

Returns:
  nothing

void CEGUI::FrameWindow::setTitleBarEnabled | ( | bool | setting | ) |

Enables or disables the title bar for the frame window.

Parameters:

  | setting | set to true to enable the title bar (if one is attached), or false to disable the title bar.

Returns:
  Nothing.

void CEGUI::FrameWindow::setTitlebarFont | ( | Font * | font | ) |

Set the font to use for the title bar text.

Parameters:

  | font | Pointer to the font to use.

Returns:
  Nothing.

void CEGUI::FrameWindow::setTitlebarFont | ( | const String & | name | ) |

Set the font to use for the title bar text.

Parameters:

  | name | String object holding the name of the font to use.

Returns:
  Nothing.

virtual bool CEGUI::FrameWindow::testClassName_impl | ( | const String & | class_name | ) | const`[inline, protected, virtual]`

Return whether this window was inherited from the given class name at some point in the inheritance heirarchy.

Parameters:

  | class_name | The class name that is to be checked.

Returns:
  true if this window was inherited from class_name. false if not.

Reimplemented from CEGUI::Window.

void CEGUI::FrameWindow::toggleRollup | ( | void |  | ) |

Toggles the state of the window between rolled-up (shaded) and normal sizes. This requires roll-up to be enabled.

Returns:
  Nothing